Attribute VB_Name = "modStack"
Option Explicit

' D++ stack module
' provides stack functionality


' VB is not C.  I could use a class, but that is messy.  so to add stacks to VB, i made this module
' basically, a stack is just an array here and these functions provide the means to push and pop from the stack
' however, instead of actually allocating memory, i just keep an array of these 'stacks'
' to access a stack, you simply provide the 'stack number' which is given when you call addstack

Public Type typeStack
    stack() As typeVar              ' array holding stack contents (dVar)
    stackSize As Integer            ' number of items in the stack
End Type
    
Public dStack() As typeStack        ' array of stacks
Public stackCount As Integer        ' number of stacks

Public Sub Push(stack, item As String)
    ' push a new string item to the top of the stack
    
    If dStack(stack).stackSize = 0 Then
        ReDim dStack(stack).stack(1 To 1) As typeVar
    ElseIf UBound(dStack(stack).stack) = dStack(stack).stackSize Then
        ReDim Preserve dStack(stack).stack(1 To UBound(dStack(stack).stack) + 1)
    End If
    dStack(stack).stackSize = dStack(stack).stackSize + 1
    dStack(stack).stack(dStack(stack).stackSize).name = ""
    dStack(stack).stack(dStack(stack).stackSize).isArray = False
    dStack(stack).stack(dStack(stack).stackSize).value = item
End Sub

Public Sub Pushh(stack)
    ' push a new dVar item to the top of the stack
    ' note that instead of passing the data itself, the dVar must be placed in tradeVar
    ' this is because VB6 won't let you pass a custom type like that
    
    If dStack(stack).stackSize = 0 Then
        ReDim dStack(stack).stack(1 To 1) As typeVar
    ElseIf UBound(dStack(stack).stack) = dStack(stack).stackSize Then
        ReDim Preserve dStack(stack).stack(1 To UBound(dStack(stack).stack) + 1)
    End If
    dStack(stack).stackSize = dStack(stack).stackSize + 1
    dStack(stack).stack(dStack(stack).stackSize) = tradeVar  'this is a cheat beacause of some gay bug in VB
End Sub

Public Function Peek(stack, Optional ignoreVars As Boolean) As String
    ' look at the top of the stack (only works for string values)
    If ignoreVars And dStack(stack).stack(dStack(stack).stackSize).name <> "" Then Exit Function
    
    tradeVar = dStack(stack).stack(dStack(stack).stackSize)
    Peek = dStack(stack).stack(dStack(stack).stackSize).value
End Function

Public Function Pop(stack) As String
    'return the top string item from the stack and remove it from the stack
    
    Pop = dStack(stack).stack(dStack(stack).stackSize).value
    dStack(stack).stack(dStack(stack).stackSize).name = ""
    dStack(stack).stackSize = dStack(stack).stackSize - 1
    If dStack(stack).stackSize = 0 Then
        Erase dStack(stack).stack
    End If
End Function

Public Function Popp(stack)
    'return the top dVar item from the stack and remove it from the stack
    ' note that instead of returning the dVar itself, the dVar is placed tradeVar where it can be recalled
    
    tradeVar = dStack(stack).stack(dStack(stack).stackSize)
    dStack(stack).stack(dStack(stack).stackSize).name = ""
    dStack(stack).stackSize = dStack(stack).stackSize - 1
    If dStack(stack).stackSize = 0 Then
        Erase dStack(stack).stack
    End If
End Function

Public Sub ClearStack(stack)
    ' erase contents of a stack
    
    dStack(stack).stackSize = 0
    Erase dStack(stack).stack
End Sub

Public Function addStack() As Integer
    ' add a new stack.  the integer returned is the stack number, and is needed to call any of the other stack operation functions
    
    stackCount = stackCount + 1
    ReDim Preserve dStack(stackCount)
    addStack = stackCount
End Function

Public Sub removeStack(stack)
    'remove memory of a stack
    
    stack = stack - 1
    ReDim Preserve dStack(stack)
    stackCount = stack
End Sub

Public Function getStackSize(stack)
    ' return the size of stack
    getStackSize = dStack(stack).stackSize
End Function

Public Sub displayStack(stack)
    ' display msgbox of stack contents (for debugging purposes only)
    Dim str As String, i As Integer
    
    For i = 1 To dStack(stack).stackSize
        If dStack(stack).stack(i).isArray Then
            str = str & "[array: " & dStack(stack).stack(i).numElements & "]" & vbCrLf
        Else
            str = str & dStack(stack).stack(i).value & vbCrLf
        End If
    Next i
    MsgBox str
End Sub
